#include "main.h"

//   
void CheckPins(uint8_t HighPin, uint8_t LowPin, uint8_t TristatePin);
void DischargePin(uint8_t PinToDischarge, uint8_t DischargeDirection);
unsigned int ReadADC(uint8_t mux);
void battery_check( void );
void show_battery( void );

struct Diode diodes[6];
uint8_t NumOfDiodes;

uint8_t b,c,e;				//  
unsigned long lhfe;			//     (long)
uint8_t PartReady;			//   
uint8_t PartMode;			//  
uint8_t PartFound, tmpPartFound;	//das gefundene Bauteil
unsigned int hfe[2];		//     ( )
unsigned int uBE[2];		//   B<->E 

unsigned long cv;

unsigned int gthvoltage;	//Gate-Schwellspannung
uint8_t tmpval, tmpval2;
char string_buf[6];


//
// =====================================    =====================================
//
int main(void) {
uint8_t tmp;
	
	LCD_DIR = 0x0F;
	LCD_PORT = 0x40;		//     /
//	 
	ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS0);			// =8
	
	SETBIT(LCD_PORT,LCD_RES);
	CLRBIT(LCD_PORT,LCD_CLK);
	CLRBIT(LCD_PORT,LCD_DAT);
	CLRBIT(LCD_PORT,LCD_RES);
	ReadADC( 5 | (1<<REFS1) );								//  
unsigned int rhval = eeprom_read_word(&R_H_VAL);			//R_H
unsigned int rlval = eeprom_read_word(&R_L_VAL);			//R_L
	SETBIT(LCD_PORT,LCD_RES);
	nokia_init();
/*
for( tmp = 0; tmp != 84; tmp++){
	nokia_gotoXY(tmp,0);
	nokia_data(0x0D);
	nokia_gotoXY(tmp,5);
	nokia_data(0xB0);
}
while(1);
*/
	PartFound = PART_NONE;
	tmpPartFound = PART_NONE;
	NumOfDiodes = 0;
	PartReady = 0;
	PartMode = 0;
//
// *********    
//
	nokia_cls();        //  
	put_qmark();		//   
	battery_check();	//  
	show_battery();		//   
/*
	nokia_cls();		//    
	put_simi();
for(;;);	
*/	
	//Alle 6 Kombinationsmglichkeiten fr die 3 Pins prfen
	CheckPins(TP1, TP2, TP3);
	CheckPins(TP1, TP3, TP2);
	CheckPins(TP2, TP1, TP3);
	CheckPins(TP2, TP3, TP1);
	CheckPins(TP3, TP2, TP1);
	CheckPins(TP3, TP1, TP2);
/*
utoa(PartFound,string_buf,10);		//      
nokia_pdec(0,0);
utoa(NumOfDiodes,string_buf,10);		//      
nokia_pdec(0,1);
for(;;);
*/
//
// ***  .      ***
//
	if(PartFound == PART_DIODE) {
		if( NumOfDiodes ) nokia_cls();
		if(NumOfDiodes == 1) {
			// ===============================  
			put_diode();
			nokia_gotoXY(21,2);
			nokia_put_char(diodes[0].Cathode + 1);
			nokia_gotoXY(56,2);
			nokia_put_char(diodes[0].Anode + 1);
			itoa(diodes[0].Voltage, string_buf, 10);
			nokia_gotoXY(7,4);
			nokia_Uf();
			nokia_pdec(35,4);
			nokia_gotoXY(63,4);
			nokia_mV();
			goto end;
		} else if(NumOfDiodes == 2) {
		// ===============================  - 
			if(diodes[0].Anode == diodes[1].Anode) {
				//  
				put_ca();
				nokia_gotoXY(38,1);
				nokia_put_char(diodes[0].Cathode + 1);
				nokia_gotoXY(14,4);
				nokia_put_char(diodes[0].Anode + 1);
				nokia_gotoXY(63,4);
				nokia_put_char(diodes[1].Anode + 1);
				goto end;
			} else if(diodes[0].Cathode == diodes[1].Cathode) {
				//    
				put_cc();
				nokia_gotoXY(38,1);
				nokia_put_char(diodes[0].Cathode + 1);
				nokia_gotoXY(14,4);
				nokia_put_char(diodes[0].Anode + 1);
				nokia_gotoXY(63,4);
				nokia_put_char(diodes[1].Anode + 1);
				goto end;
			} else if ((diodes[0].Cathode == diodes[1].Anode) && (diodes[1].Cathode == diodes[0].Anode)) {
				//  
				put_anti();
				goto end;
			}
		} else if(NumOfDiodes == 3) {
			//Serienschaltung aus 2 Dioden; wird als 3 Dioden erkannt
			b = 3;
			c = 3;
			/* berprfen auf eine fr eine Serienschaltung von 2 Dioden mgliche Konstellation
				Dafr mssen 2 der Kathoden und 2 der Anoden bereinstimmen.
				Das kommmt daher, dass die Dioden als 2 Einzeldioden und ZUSTZLICH als eine "groe" Diode erkannt werden.
			*/
			if((diodes[0].Anode == diodes[1].Anode) || (diodes[0].Anode == diodes[2].Anode)) b = diodes[0].Anode;
			if(diodes[1].Anode == diodes[2].Anode) b = diodes[1].Anode;

			if((diodes[0].Cathode == diodes[1].Cathode) || (diodes[0].Cathode == diodes[2].Cathode)) c = diodes[0].Cathode;
			if(diodes[1].Cathode == diodes[2].Cathode) c = diodes[1].Cathode;
			if((b<3) && (c<3)) {				
				put_serial();
				nokia_gotoXY(14,3);
				nokia_put_char(c + 1);
				nokia_gotoXY(63,3);
				nokia_put_char(b + 1);
				nokia_gotoXY(37,0);
				nokia_put_char(4-b-c);	//    .
				goto end;
			}
		}
	} else
	if (PartFound == PART_TRANSISTOR) {
// ***    ***
		if(PartReady == 0) {	//Wenn 2. Prfung nie gemacht, z.B. bei Transistor mit Schutzdiode
			hfe[1] = hfe[0];
			uBE[1] = uBE[0];
		}
		if((hfe[0]>hfe[1])) {	//Wenn der Verstrkungsfaktor beim ersten Test hher war: C und E vertauschen!
			hfe[1] = hfe[0];
			uBE[1] = uBE[0];
			tmp = c;
			c = e;
			e = tmp;
		}
    	nokia_cls();
		//    
		put_bipolar();
		//     npn  pnp 
		if(PartMode == PART_MODE_NPN) put_an(); else put_ap();
		//    ,    
		if(NumOfDiodes > 2)	{ if(PartMode == PART_MODE_NPN) put_npd(); else put_ppd(); }
		//   
		nokia_gotoXY(21,1);		//   
		nokia_put_char(b + 1);
		nokia_gotoXY(43,0);		//   
		nokia_put_char(c + 1);
		nokia_gotoXY(43,2);		//   
		nokia_put_char(e + 1);
		//      
		// hFE =   /  
		lhfe = hfe[1];
		//    RH/RL (470K/680)
		lhfe *= (((unsigned long)rhval * 100) / (unsigned long)rlval);
		if(uBE[1]<11) uBE[1] = 11;		//     "0".
		lhfe /= uBE[1];
		hfe[1] = (unsigned int) lhfe;	//    uint (0..65535)
		nokia_gotoXY(0,4);
		nokia_hFE();
		utoa(hfe[1], string_buf, 10);
		nokia_pdec(35,4);
/*
utoa(NumOfDiodes,string_buf,10);		//      
nokia_pdec(0,0);
for(;;);
*/
		for(c=0;c<NumOfDiodes;c++) {
			if(((diodes[c].Cathode == e) && (diodes[c].Anode == b) && (PartMode == PART_MODE_NPN)) || ((diodes[c].Anode == e) && (diodes[c].Cathode == b) && (PartMode == PART_MODE_PNP))) {
				nokia_gotoXY(7,5);
				nokia_Uf();
				itoa(diodes[c].Voltage, string_buf, 10);
				nokia_pdec(35,5);
				nokia_gotoXY(70, 5);
				nokia_mV();
				goto end;
			}
		}
		goto end;
	} else
	if (PartFound == PART_FET) {	//JFET oder MOSFET
// ***   MOS   JFET ***
		nokia_cls();
		if( (PartMode == PART_MODE_N_D_MOS) || (PartMode == PART_MODE_P_D_MOS)) {
				if( PartMode & 1 ) put_ndmos(); else put_pdmos(); 
		} else {
			if((PartMode==PART_MODE_N_JFET) || (PartMode==PART_MODE_P_JFET)) {
				if( PartMode & 1 ) put_nfet(); else put_pfet(); 
			} else {
				if( PartMode & 1 ) put_nemos(); else put_pemos(); 
			}
		}
		nokia_gotoXY(21,2);
		nokia_put_char(b + 1);
		nokia_gotoXY(49,2);
		nokia_put_char(e + 1);
		nokia_gotoXY(49,0);
		nokia_put_char(c + 1);
//    		
		if((NumOfDiodes > 0) && (PartMode < 3)) {	//MOSFET mit Schutzdiode; gibt es nur bei Anreicherungs-FETs
	//       
			if( PartMode & 1 ) N_prot_D(); else P_prot_D();
		}
//     MOSFET
		if(PartMode < 3) {	//Anreicherungs-MOSFET
			gthvoltage=(gthvoltage/8);
			nokia_gotoXY(0,4);
			nokia_Vt();
			utoa(gthvoltage, string_buf, 10);	//Gate-Schwellspannung, wurde zuvor ermittelt
			nokia_pdec(28,4);
			nokia_gotoXY(70,4);
			nokia_mV();
		}
		goto end; //   .
	} else if (PartFound == PART_THYRISTOR) {
//  	
		nokia_cls();
		put_tyry();				//   
		nokia_gotoXY(21,2);		//   
		nokia_put_char(c+1);
		nokia_gotoXY(56,3);
		nokia_put_char(e+1);
		nokia_gotoXY(56,1);
		nokia_put_char(b+1);
//		GAK=bce
		goto end; //   .
	} else if (PartFound == PART_TRIAC) {
 //  
		nokia_cls();
		put_simi();				//   
//		b=Gate e=A1 c=A2
		nokia_gotoXY(56,0);		//   
		nokia_put_char(b+1);
		nokia_gotoXY(21,2);
		nokia_put_char(e+1);
		nokia_gotoXY(56,2);
		nokia_put_char(c+1);
	} //   ...
end:
	show_battery();				// ""  
	CLRBIT(ADCSRA,ADEN);		//  
	SETBIT(ACSR,ACD);			//  
	ADMUX = 0x00;				//   
	MCUCR = 0xA0;
	DDRD = 0x08;				//       !     
	PORTD = 0x08;
	DDRB = 0x00;
	PORTB = 0x00;
	DDRC = 0x00;
	PORTC = 0x00;
asm volatile("sleep");			// ""    .
//
// *************** END OF MAIN ************
}

//
// ==================================
//
void DischargePin(uint8_t PinToDischarge, uint8_t DischargeDirection) {
	/*Anschluss eines Bauelementes kurz(10ms) auf ein bestimmtes Potenzial legen
		Diese Funktion ist zum Entladen von MOSFET-Gates vorgesehen, um Schutzdioden u.. in MOSFETs erkennen zu knnen
		Parameter:
		PinToDischarge: zu entladender Pin
		DischargeDirection: 0 = gegen Masse (N-Kanal-FET), 1= gegen Plus(P-Kanal-FET)
	*/
	uint8_t tmpval;
	tmpval = (PinToDischarge * 2);		//ntig wegen der Anordnung der Widerstnde

	if(DischargeDirection) R_PORT |= (1<<tmpval);			//R_L aus
	R_DDR |= (1<<tmpval);			//Pin auf Ausgang und ber R_L auf Masse
	_delay_ms(10);
	R_DDR &= ~(1<<tmpval);			//Pin wieder auf Eingang
	if(DischargeDirection) R_PORT &= ~(1<<tmpval);			//R_L aus
}
//
// ==================================
//

unsigned int ReadADC(uint8_t mux) {
unsigned int adcx = 0;
	ADMUX = mux | (1<<REFS0);							//  = U 
	for(uint8_t j = 0; j != 8; j++) {					// 8 
		ADCSRA |= (1<<ADSC);
		while (ADCSRA&(1<<ADSC));
		adcx += ADCW;									// 
	}
	return adcx >>= 3;									//  
}

//   
#define b100	3		//   100%		
#define b75		2		//    75%		
#define b25		1		//    25%		
#define b0		0		//  		

char	battery;

void battery_check( void ){
signed int U = ReadADC( 5 | (1<<REFS1) );				//   = 2.56 
	if ( U > 800 ) battery = b100; else					//  8  -   (2.23  )
	if ( U > 700 ) battery =  b75; else					//  7  - 75%     (1.98  )
	if ( U > 600 ) battery =  b25; else					//  6  - 25% 	   (1.74  )
	battery = b0;										//    -  6  (1.49  )
}	

void show_battery( void ){
	switch( battery ){
		case b100: put_batt100(); break;
		case b75: put_batt75(); break;
		case b25: put_batt25(); break;
		case b0: put_batt0(); break;
		default: ;
	}
}	

/*
//   (  )
utoa(PartFound,string_buf,10);
nokia_pdec(0,0);
utoa(PartMode,string_buf,10);
nokia_pdec(0,2);
utoa(NumOfDiodes,string_buf,10);
nokia_pdec(0,3);
for(;;);
*/

void CheckPins(uint8_t HighPin, uint8_t LowPin, uint8_t TristatePin) {
	/*
	Funktion zum Testen der Eigenschaften des Bauteils bei der angegebenen Pin-Belegung
	Parameter:
	HighPin: Pin, der anfangs auf positives Potenzial gelegt wird
	LowPin: Pin, der anfangs auf negatives Potenzial gelegt wird
	TristatePin: Pin, der anfangs offen gelassen wird

	Im Testverlauf wird TristatePin natrlich auch positiv oder negativ geschaltet.
	*/
	unsigned int adcv[6];
	uint8_t tmpval, tmpval2;
	/*
		HighPin wird fest auf Vcc gelegt
		LowPin wird ber R_L auf GND gelegt
		TristatePin wird hochohmig geschaltet, dafr ist keine Aktion ntig
	*/
	//Pins setzen
	tmpval = (LowPin * 2);			//ntig wegen der Anordnung der Widerstnde
	R_DDR = (1<<tmpval);			//Low-Pin auf Ausgang und ber R_L auf Masse
	R_PORT = 0;
	ADC_DDR = (1<<HighPin);			//High-Pin auf Ausgang
	ADC_PORT = (1<<HighPin);		//High-Pin fest auf Vcc
	_delay_ms(5);
	//Bei manchen MOSFETs muss das Gate (TristatePin) zuerst entladen werden
	//N-Kanal:
	DischargePin(TristatePin,0);
	//Spannung am Low-Pin ermitteln
	adcv[0] = ReadADC(LowPin);
	if(adcv[0] < 200) goto next;	//Sperrt das Bauteil jetzt?
	//sonst: Entladen fr P-Kanal (Gate auf Plus)
	DischargePin(TristatePin,1);
	//Spannung am Low-Pin ermitteln
	adcv[0] = ReadADC(LowPin);

next:

	if(adcv[0] > 19) {//Bauteil leitet ohne Steuerstrom etwas
		//Test auf N-JFET oder selbstleitenden N-MOSFET
		R_DDR |= (2<<(TristatePin*2));	//Tristate-Pin (vermutetes Gate) ber R_H auf Masse
		_delay_ms(20);
		adcv[1] = ReadADC(LowPin);		//Spannung am vermuteten Source messen
		R_PORT |= (2<<(TristatePin*2));	//Tristate-Pin (vermutetes Gate) ber R_H auf Plus
		_delay_ms(20);
		adcv[2] = ReadADC(LowPin);		//Spannung am vermuteten Source erneut messen
		//Wenn es sich um einen selbstleitenden MOSFET oder JFET handelt, msste adcv[1] > adcv[0] sein
		if(adcv[2]>(adcv[1]+100)) {
			//Spannung am Gate messen, zur Unterscheidung zwischen MOSFET und JFET
			ADC_PORT = 0;
			ADC_DDR = (1<<LowPin);	//Low-Pin fest auf Masse
			tmpval = (HighPin * 2);		//ntig wegen der Anordnung der Widerstnde
			R_DDR |= (1<<tmpval);			//High-Pin auf Ausgang
			R_PORT |= (1<<tmpval);			//High-Pin ber R_L auf Vcc
			_delay_ms(20);
			adcv[2] = ReadADC(TristatePin);		//Spannung am vermuteten Gate messen
			if(adcv[2]>800) {	//MOSFET
				PartFound = PART_FET;			//N-Kanal-MOSFET
				PartMode = PART_MODE_N_D_MOS;	//Verarmungs-MOSFET
			} else {	//JFET (pn-bergang zwischen G und S leitet)
				PartFound = PART_FET;			//N-Kanal-JFET
				PartMode = PART_MODE_N_JFET;
			}
			b = TristatePin;
			c = HighPin;
			e = LowPin;
		}
		ADC_PORT = 0;
		//Test auf P-JFET oder selbstleitenden P-MOSFET
		ADC_DDR = (1<<LowPin);	//Low-Pin (vermuteter Drain) fest auf Masse, Tristate-Pin (vermutetes Gate) ist noch ber R_H auf Plus
		tmpval = (HighPin * 2);			//ntig wegen der Anordnung der Widerstnde
		R_DDR |= (1<<tmpval);			//High-Pin auf Ausgang
		R_PORT |= (1<<tmpval);			//High-Pin ber R_L auf Vcc
		_delay_ms(20);
		adcv[1] = ReadADC(HighPin);		//Spannung am vermuteten Source messen
		R_PORT = (1<<tmpval);			//Tristate-Pin (vermutetes Gate) ber R_H auf Masse
		_delay_ms(20);
		adcv[2] = ReadADC(HighPin);		//Spannung am vermuteten Source erneut messen
		//Wenn es sich um einen selbstleitenden P-MOSFET oder P-JFET handelt, msste adcv[0] > adcv[1] sein
		if(adcv[1]>(adcv[2]+100)) {
			//Spannung am Gate messen, zur Unterscheidung zwischen MOSFET und JFET
			ADC_PORT = (1<<HighPin);	//High-Pin fest auf Plus
			ADC_DDR = (1<<HighPin);		//High-Pin auf Ausgang
			_delay_ms(20);
			adcv[2] = ReadADC(TristatePin);		//Spannung am vermuteten Gate messen
			if(adcv[2]<200) {	//MOSFET
				PartFound = PART_FET;			//P-Kanal-MOSFET
				PartMode = PART_MODE_P_D_MOS;	//Verarmungs-MOSFET
			} else {	//JFET (pn-bergang zwischen G und S leitet)
				PartFound = PART_FET;			//P-Kanal-JFET
				PartMode = PART_MODE_P_JFET;
			}
			b = TristatePin;
			c = LowPin;
			e = HighPin;
		}
	}
	//Pins erneut setzen
	tmpval = (LowPin * 2);			//ntig wegen der Anordnung der Widerstnde
	R_DDR = (1<<tmpval);			//Low-Pin auf Ausgang und ber R_L auf Masse
	R_PORT = 0;
	ADC_DDR = (1<<HighPin);			//High-Pin auf Ausgang
	ADC_PORT = (1<<HighPin);		//High-Pin fest auf Vcc
	_delay_ms(5);
	
	if(adcv[0] < 200) {	//Wenn das Bauteil keinen Durchgang zwischen HighPin und LowPin hat
		//Test auf pnp
		tmpval2 = (TristatePin * 2);		//ntig wegen der Anordnung der Widerstnde
		R_DDR |= (1<<tmpval2);			//Tristate-Pin ber R_L auf Masse, zum Test auf pnp
		_delay_ms(2);
		adcv[1] = ReadADC(LowPin);		//Spannung messen
		if(adcv[1] > 700) {
			//Bauteil leitet => pnp-Transistor o..
			//Verstrkungsfaktor in beide Richtungen messen
			R_DDR = (1<<tmpval);		//Tristate-Pin (Basis) hochohmig
			tmpval2++;
			R_DDR |= (1<<tmpval2);		//Tristate-Pin (Basis) ber R_H auf Masse

			_delay_ms(10);
			adcv[1] = ReadADC(LowPin);		//Spannung am Low-Pin (vermuteter Kollektor) messen
			adcv[2] = ReadADC(TristatePin);	//Basisspannung messen
			//Prfen, ob Test schon mal gelaufen
			if((PartFound == PART_TRANSISTOR) || (PartFound == PART_FET)) PartReady = 1;
			hfe[PartReady] = adcv[1];
			uBE[PartReady] = adcv[2];

			if(PartFound != PART_THYRISTOR) {
				if(adcv[2] > 200) {
					PartFound = PART_TRANSISTOR;	//PNP-Transistor gefunden (Basis wird "nach oben" gezogen)
					PartMode = PART_MODE_PNP;
				} else {
					if(adcv[0] < 20) {	//Durchlassspannung im gesperrten Zustand gering genug? (sonst werden D-Mode-FETs flschlicherweise als E-Mode erkannt)
					 	PartFound = PART_FET;			//P-Kanal-MOSFET gefunden (Basis/Gate wird NICHT "nach oben" gezogen)
						PartMode = PART_MODE_P_E_MOS;
						//Messung der Gate-Schwellspannung
						tmpval = (1<<LowPin);
						tmpval2 = R_DDR;
						ADMUX = TristatePin | (1<<REFS0);
						gthvoltage = 0;
						for(b=0;b<13;b++) {
							wdt_reset();
							DischargePin(TristatePin,1);
							while (!(ADC_PIN&tmpval));  // Warten, bis der MOSFET schaltet und Drain auf high geht
							R_DDR = 0;
							ADCSRA |= (1<<ADSC);
							while (ADCSRA&(1<<ADSC));
							gthvoltage += (1023 - ADCW);
							R_DDR = tmpval2;
						}
						gthvoltage *= 3;	//Umrechnung in mV, zusammen mit der Division durch 8 (bei der LCD-Anzeige)
					}
				}
				b = TristatePin;
				c = LowPin;
				e = HighPin;
			}
		}

		//Tristate (vermutete Basis) auf Plus, zum Test auf npn
		ADC_PORT = 0;					//Low-Pin fest auf Masse
		tmpval = (TristatePin * 2);		//ntig wegen der Anordnung der Widerstnde
		tmpval2 = (HighPin * 2);		//ntig wegen der Anordnung der Widerstnde
		R_DDR = (1<<tmpval) | (1<<tmpval2);			//High-Pin und Tristate-Pin auf Ausgang
		R_PORT = (1<<tmpval) | (1<<tmpval2);		//High-Pin und Tristate-Pin ber R_L auf Vcc
		ADC_DDR = (1<<LowPin);			//Low-Pin auf Ausgang
		_delay_ms(10);
		adcv[1] = ReadADC(HighPin);		//Spannung am High-Pin messen
		if(adcv[1] < 500) {
			if(PartReady==1) goto testend;
			//Bauteil leitet => npn-Transistor o..

			//Test auf Thyristor:
			//Gate entladen
			
			R_PORT = (1<<tmpval2);			//Tristate-Pin (Gate) ber R_L auf Masse
			_delay_ms(10);
			R_DDR = (1<<tmpval2);			//Tristate-Pin (Gate) hochohmig
			//Test auf Thyristor
			_delay_ms(5);
			adcv[3] = ReadADC(HighPin);		//Spannung am High-Pin (vermutete Anode) erneut messen
			
			R_PORT = 0;						//High-Pin (vermutete Anode) auf Masse
			_delay_ms(5);
			R_PORT = (1<<tmpval2);			//High-Pin (vermutete Anode) wieder auf Plus
			_delay_ms(5);
			adcv[2] = ReadADC(HighPin);		//Spannung am High-Pin (vermutete Anode) erneut messen
			if((adcv[3] < 500) && (adcv[2] > 900)) {	//Nach Abschalten des Haltestroms muss der Thyristor sperren
				//war vor Abschaltung des Triggerstroms geschaltet und ist immer noch geschaltet obwohl Gate aus => Thyristor
				PartFound = PART_THYRISTOR;
				//Test auf Triac
				R_DDR = 0;
				R_PORT = 0;
				ADC_PORT = (1<<LowPin);	//Low-Pin fest auf Plus
				_delay_ms(5);
				R_DDR = (1<<tmpval2);	//HighPin ber R_L auf Masse
				_delay_ms(5);
				if(ReadADC(HighPin) > 50) goto savenresult;	//Spannung am High-Pin (vermuteter A2) messen; falls zu hoch: Bauteil leitet jetzt => kein Triac
				R_DDR |= (1<<tmpval);	//Gate auch ber R_L auf Masse => Triac msste znden
				_delay_ms(5);
				if(ReadADC(TristatePin) < 200) goto savenresult; //Spannung am Tristate-Pin (vermutetes Gate) messen; Abbruch falls Spannung zu gering
				if(ReadADC(HighPin) < 150) goto savenresult; //Bauteil leitet jetzt nicht => kein Triac => Abbruch
				R_DDR = (1<<tmpval2);	//TristatePin (Gate) wieder hochohmig
				_delay_ms(5);
				if(ReadADC(HighPin) < 150) goto savenresult; //Bauteil leitet nach Abschalten des Gatestroms nicht mehr=> kein Triac => Abbruch
				R_PORT = (1<<tmpval2);	//HighPin ber R_L auf Plus => Haltestrom aus
				_delay_ms(5);
				R_PORT = 0;				//HighPin wieder ber R_L auf Masse; Triac msste jetzt sperren
				_delay_ms(5);
				if(ReadADC(HighPin) > 50) goto savenresult;	//Spannung am High-Pin (vermuteter A2) messen; falls zu hoch: Bauteil leitet jetzt => kein Triac
				PartFound = PART_TRIAC;
				PartReady = 1;
				goto savenresult;
			}
			//Test auf Transistor oder MOSFET
			tmpval++;
			R_DDR |= (1<<tmpval);		//Tristate-Pin (Basis) auf Ausgang
			R_PORT |= (1<<tmpval);		//Tristate-Pin (Basis) ber R_H auf Plus
			_delay_ms(50);
			adcv[1] = ReadADC(HighPin);		//Spannung am High-Pin (vermuteter Kollektor) messen
			adcv[2] = ReadADC(TristatePin);	//Basisspannung messen

			if((PartFound == PART_TRANSISTOR) || (PartFound == PART_FET)) PartReady = 1;	//prfen, ob Test schon mal gelaufen
			hfe[PartReady] = 1023 - adcv[1];
			uBE[PartReady] = 1023 - adcv[2];
			if(adcv[2] < 500) {
				PartFound = PART_TRANSISTOR;	//NPN-Transistor gefunden (Basis wird "nach unten" gezogen)
				PartMode = PART_MODE_NPN;
			} else {
				if(adcv[0] < 20) {	//Durchlassspannung im gesperrten Zustand gering genug? (sonst werden D-Mode-FETs flschlicherweise als E-Mode erkannt)
					PartFound = PART_FET;			//N-Kanal-MOSFET gefunden (Basis/Gate wird NICHT "nach unten" gezogen)
					PartMode = PART_MODE_N_E_MOS;
					//Gate-Schwellspannung messen
					tmpval2 = R_DDR;
					tmpval=(1<<HighPin);
					ADMUX = TristatePin | (1<<REFS0);
					gthvoltage = 0;
					for(b=0;b<13;b++) {
						wdt_reset();
						DischargePin(TristatePin,0);
						while ((ADC_PIN&tmpval));  // Warten, bis der MOSFET schaltet und Drain auf low geht
						R_DDR = 0;
						R_PORT = 0;
						ADCSRA |= (1<<ADSC);
						while (ADCSRA&(1<<ADSC));
						gthvoltage += ADCW;
						R_DDR = tmpval2;
						R_PORT = tmpval2;
					}
					gthvoltage *= 3;	//Umrechnung in mV, zusammen mit der Division durch 8 (bei der LCD-Anzeige)
				}
			}
			savenresult:
			b = TristatePin;
			c = HighPin;
			e = LowPin;
		}
		ADC_DDR = 0;
		ADC_PORT = 0;
		//Fertig
	} else {	//Durchgang
		//Test auf Diode
		tmpval2 = (2<<(2*HighPin));	//R_H
		tmpval = (1<<(2*HighPin));	//R_L
		ADC_PORT = 0;
		ADC_DDR = (1<<LowPin);	//Low-Pin fest auf Masse, High-Pin ist noch ber R_L auf Vcc
		DischargePin(TristatePin,1);	//Entladen fr P-Kanal-MOSFET
		_delay_ms(5);
		adcv[0] = ReadADC(HighPin) - ReadADC(LowPin);
		R_DDR = tmpval2;	//High-Pin ber R_H auf Plus
		R_PORT = tmpval2;
		_delay_ms(5);
		adcv[2] = ReadADC(HighPin) - ReadADC(LowPin);
		R_DDR = tmpval;	//High-Pin ber R_L auf Plus
		R_PORT = tmpval;
		DischargePin(TristatePin,0);	//Entladen fr N-Kanal-MOSFET
		_delay_ms(5);
		adcv[1] = ReadADC(HighPin) - ReadADC(LowPin);
		R_DDR = tmpval2;	//High-Pin ber R_H  auf Plus
		R_PORT = tmpval2;
		_delay_ms(5);
		adcv[3] = ReadADC(HighPin) - ReadADC(LowPin);
		/*Ohne das Entladen kann es zu Falscherkennungen kommen, da das Gate eines MOSFETs noch geladen sein kann.
			Die zustzliche Messung mit dem "groen" Widerstand R_H wird durchgefhrt, um antiparallele Dioden von
			Widerstnden unterscheiden zu knnen.
			Eine Diode hat eine vom Durchlassstrom relativ unabhngige Durchlassspg.
			Bei einem Widerstand ndert sich der Spannungsabfall stark (linear) mit dem Strom.
		*/
		if(adcv[0] > adcv[1]) {
			adcv[1] = adcv[0];	//der hhere Wert gewinnt
			adcv[3] = adcv[2];
		}

		if((adcv[1] > 30) && (adcv[1] < 950)) { //Spannung liegt ber 0,15V und unter 4,64V => Ok
			if((PartFound == PART_NONE) || (PartFound == PART_RESISTOR)) PartFound = PART_DIODE;	//Diode nur angeben, wenn noch kein anderes Bauteil gefunden wurde. Sonst gbe es Probleme bei Transistoren mit Schutzdiode
			diodes[NumOfDiodes].Anode = HighPin;
			diodes[NumOfDiodes].Cathode = LowPin;
			diodes[NumOfDiodes].Voltage = (adcv[1]*54/11);	// ca. mit 4,9 multiplizieren, um aus dem ADC-Wert die Spannung in Millivolt zu erhalten
			NumOfDiodes++;
			for(uint8_t i=0;i<NumOfDiodes;i++) {
				if((diodes[i].Anode == LowPin) && (diodes[i].Cathode == HighPin)) {	//zwei antiparallele Dioden: Defekt oder Duo-LED
					if((adcv[3]*64) < (adcv[1] / 5)) {	//Durchlassspannung fllt bei geringerem Teststrom stark ab => Defekt
						if(i<NumOfDiodes) {
							for(uint8_t j=i;j<(NumOfDiodes-1);j++) {
								diodes[j].Anode = diodes[j+1].Anode;
								diodes[j].Cathode = diodes[j+1].Cathode;
								diodes[j].Voltage = diodes[j+1].Voltage;
							}
						}
						NumOfDiodes -= 2;
					}
				}
			}
		}
	}
testend:
	ADC_DDR = 0;
	ADC_PORT = 0;
	R_DDR = 0;
	R_PORT = 0;
}
