#include <avr/io.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include <stdlib.h>
#include <string.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include <math.h>
#include <avr/pgmspace.h>
#include "global.h"

#define MCU_STATUS_REG MCUCSR

/***********    -   . *****************/

#define ADC_PORT PORTC
#define ADC_DDR DDRC
#define ADC_PIN PINC
#define TP1 PC0
#define TP2 PC1
#define TP3 PC2

#define R_DDR DDRB
#define R_PORT PORTB

/* 
	      
	RLx = 680R-  Test-Pin x
	RHx = 470k-  Test-Pin x

	RL1 an Pin 0
	RH1 an Pin 1
	RL2 an Pin 2
	RH2 an Pin 3
	RL3 an Pin 4
	RH3 an Pin 5
*/

//   
#define PART_NONE 0
#define PART_DIODE 1
#define PART_TRANSISTOR 2
#define PART_FET 3
#define PART_TRIAC 4
#define PART_THYRISTOR 5
#define PART_RESISTOR 6
#define PART_CAPACITOR 7
//  
//	FETs
#define PART_MODE_N_E_MOS 1
#define PART_MODE_P_E_MOS 2
#define PART_MODE_N_D_MOS 3
#define PART_MODE_P_D_MOS 4
#define PART_MODE_N_JFET 5
#define PART_MODE_P_JFET 6
//	Bipolar
#define PART_MODE_NPN 1
#define PART_MODE_PNP 2

#include "eeprom.inc"

struct Diode {
	uint8_t Anode;
	uint8_t Cathode;
	int Voltage;
};

