#include "nokia_3310.h"

char *imgp;

//
//    
//
void nokia_load( uint8_t data){
uint8_t tmp = data;
uint8_t i;
	for( i = 0; i != 8; i++ ){
		if( tmp & 0x80 )
			SETBIT(LCD_PORT,LCD_DAT);
		else
			CLRBIT(LCD_PORT,LCD_DAT);
		SETBIT(LCD_PORT,LCD_CLK);
		tmp <<= 1;
		CLRBIT(LCD_PORT,LCD_CLK);
	}
}
//
//    
//
void nokia_cmd(uint8_t cmd){
	CLRBIT(LCD_PORT,LCD_CD);
	nokia_load(cmd);
}
//
//    
//
void nokia_data( uint8_t ch ){
	SETBIT(LCD_PORT,LCD_CD);
	nokia_load(ch);
}
//
//     
//
void nokia_gotoXY( char x, char y){
	nokia_cmd( 0x40 | y );
	nokia_cmd( 0x80 | x );
}
//
//    (   )
//
void nokia_cls( void ){
/*
int i,j=0;
	for( j = 0; j != 8; j++ ){
		nokia_gotoXY(0,j);
		for( i = 0; i != 102; i++ ) nokia_data(0x00);
	}
	nokia_gotoXY(0,0);
*/
int i;
	nokia_gotoXY(0,0);
	for( i = 0; i != 102*84; i++ )  nokia_data(0x00);
}
//
//  
//
void nokia_init(void){
	nokia_cmd( 0x21 );			//   .
//	nokia_cmd( 0xB2);			// LCD Vop (Contrast). (B2)
	nokia_cmd( 0xC8 );

//    
// 0x80 + (3.06 + 0x32*0.06) = 0x80 + 0x32 = 0xB2 [3.06 + 3.00 = 6.06V] 
	nokia_cmd( 0x06 );			//  2.
	nokia_cmd( 0x13 );			// LCD bias mode 1:48.
//
	nokia_cmd( 0x40 + 63 );			//    ""
//
	nokia_cmd( 0x20 );			//   .
//     (PD6=0)    (PD6=1) ( 12)
	if( BITON(PIND,6) ) nokia_cmd( 0x0C ); else nokia_cmd( 0x0D );
	nokia_cls();
}
//
//    .  -
//   :
// x   -   X   (0..83)
// y   -   Y   (0..5)
// xs  -      
// ys  -      
//
void nokia_put_img(char x, char y, char xs, char ys, char *p){
char i, j;
//int i;
	nokia_gotoXY(x,y);
	for( j = y; j != (y+ys); j++ ){
		nokia_gotoXY(x,j);
		for( i = x; i != (x + xs); i++ ) nokia_data( pgm_read_byte(p++) );
	}
}
//
//     
//
void nokia_Vt( void ){
	nokia_put_char(13);
	nokia_put_char(23);
	nokia_put_char(18);
}

void nokia_hFE( void){
	nokia_put_char(14);
	nokia_put_char(11);
	nokia_put_char(10);
	nokia_put_char(18);
}

void nokia_Uf( void ){
	nokia_put_char(12);
	nokia_put_char(15);
	nokia_put_char(18);
}

void nokia_mV( void ){
	nokia_put_char(16);
	nokia_put_char(13);
}
//
//   
//
void nokia_put_char( char code ){
char *p = &sym[(int)code*7];
char i;
	for( i = 0; i != 7; i++ ) nokia_data( pgm_read_byte(p++) );
}
//
//   ,     
//
void nokia_pdec(char col,  char raw ){
char *p = &string_buf[0];
	nokia_gotoXY(col,raw);
	while( *p ) nokia_put_char(*p++ - 0x30);
}
