#ifndef __NOKIA_3310_H_
#define _NOKIA_3310_H_

#include <avr/io.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "config.h"
#include "global.h"

#define LCD_PORT	PORTD
#define LCD_DIR		DDRD
#define LCD_CLK		0
#define LCD_DAT		1
#define LCD_CD		2
#define LCD_RES		3

void nokia_cmd( uint8_t );
void nokia_data( uint8_t );
void nokia_init( void );
void nokia_gotoXY( char, char );
void nokia_load( uint8_t );
void nokia_cls( void );
void nokia_full_screen( void );
void nokia_put_img(char, char, char, char, char * );
void nokia_put_char( char code );
void nokia_hFE( void );
void nokia_Cg( void );
void nokia_pF( void );
void nokia_mV( void );
void nokia_nF( void );
void nokia_Uf( void );
void nokia_Vt( void );
void nokia_pdec( char, char );

#define GLCD_PIXELX         (84)
#define GLCD_PIXELY         (48)
#define CACHE_SIZE     (GLCD_PIXELX * GLCD_PIXELY) / 8

#endif
